<?php
/*
Plugin Name: flexo-facebook-manager
Version: 1.0002
Contributors: flexostudio
Tags: facebook, comments, like, posts
Author: Grigor Grigorov, Mariela Stefanova, Flexo Studio Team
Plugin URI: http://www.flexostudio.com/wordpress-plugins-flexo-utils.html
*/

class flexoFBManager {
	public static $weight_comments = 1.5;
	public static $weight_likes		 = 1;
	/* =_ functions
	-------------------------------------------------------------------------------------- */		
	public static function get_url($post_id=null){
		$permalink	=	get_permalink($post_id);
		$rurl = urlencode($permalink);
		return $rurl;	
	}
	
	/* =public functions
	-------------------------------------------------------------------------------------- */		
	public static function the_facebook(){
		
		echo get_facebook($post_id=null);
		
	}
	
	public static function get_facebook($post_id=null, $case='default'){

		return self::get_form($post_id,$case);
	}
	public static function get_fb_likes_field_name(){
		return "fb_likes";
	}
	
	
	/* =LIKES section
	-------------------------------------------------------------------------------------- */	
	public static function get_data($post_id=null){
		$graph 	= "http://graph.facebook.com/?id=".self::get_url($post_id);
		$obj		=	json_decode(file_get_contents($graph));
		return $obj;	
	}
	
	public static function get_likes($post_id=null){
		$obj	=	self::get_data($post_id);
		return $obj->shares;
	}
	
	public static function update_likes($post_id=null){
		if($post_id == null):
			$post_id = get_the_ID();
		endif;

		$data		=	self::get_data($post_id);
		$likes	=	intval($data->shares);//flexoFBManager::get_likes($post_id);
		$comments	=	intval($data->comments);
		
		$vars		=	flexoFBManager::post_vars($post_id);
		
		$update_score = false;
		
		flexoFBManager::save_custom($post_id,$field = "fb_likes" , $value = $likes);
		flexoFBManager::save_custom($post_id,$field = "fb_comments" , $value = $comments);
		flexoFBManager::save_custom($post_id,$field = "fb_score" , $likes * self::$weight_likes + $comments * self::$weight_comments + 1);
		flexoFBManager::save_custom($post_id,$field = "fb_need_update" , "no");
		
		return $likes;
	}
	
	public static function reset_data($post_id=null){
		if($post_id == null):
			$post_id = get_the_ID();
		endif;
		flexoFBManager::save_custom($post_id,$field = "fb_need_update" , $value = "yes");
	}
	
	/* =COMMENTS section
	-------------------------------------------------------------------------------------- */	
	public static function get_comments($post_id=null){
		$graph 	= "http://graph.facebook.com/comments/?ids=".flexoFBManager::get_url($post_id);
		$obj		=	json_decode(file_get_contents($graph));
		print_r($graph);exit;
		return $obj->data;
	}

	public static function update_comments($post_id=null){
		if($post_id == null):
			$post_id = get_the_ID();
		endif;

		$comments_raw	=	flexoFBManager::get_comments($post_id);
		$vars		=	flexoFBManager::post_vars($post_id);
		
		$comments	=	count($comments_raw);
		if($vars['comments'] !== $comments):
			flexoFBManager::save_custom($post_id,$field = "fb_comments" , $value = $comments);
		endif;
		
		return $comments;
	}	

	public static function update_all($post_id = null){
		flexoFBManager::update_likes($post_id);
		flexoFBManager::update_comments($post_id);
	}
	
	public static function reset_all($post_id = null) {
		self::reset_data($post_id);
	}
	
	/* =WP Section
	-------------------------------------------------------------------------------------- */		
	public static function post_vars($post_id=null){
		//todo if custom post_id
		$custom = get_post_custom();
		$ret			=	array(
			'likes'			=> 	$custom["fb_likes"][0], 
			'comments'	=> 	$custom["fb_comments"][0],
			'fb_check'				=>	$custom["fb_check"][0],
			'fb_need_update' 	=>	$custom["fb_need_update"][0],
			'fb_score'				=>	$custom["fb_score"][0],
		);
		return $ret;		
	}	
	
	public static function save_custom($post_id,$field,$value){
		update_post_meta($post_id, $field, $value);
	}
	  
	public static $moreJS;
	public static function js_unload($post_id=null){
		if($post_id == null):
			$post_id = get_the_ID();
		endif;
		$url = plugins_url( 'update.php' , __FILE__ );
		self::$moreJS .= '<script type="text/javascript">
			jQuery(window).unload(function() {
				jQuery.ajax({
						type: "GET",
						url: "'.$url.'",
						data: "p='.$post_id.'",
						success: function(msg){
						}				
				});
		});
		</script>';
	}
	
	public static function wp_footer(){
		//todo da se proveri zasto ne raboti pri chrome
		//echo self::$moreJS;
	}

	public static function get_cache_likes($post_id=null){
		$ret	=	0;
		$vars	=	flexoFBManager::post_vars($post_id);
		if($vars['likes'] == null || $vars['fb_need_update'] == 'yes'){
			$ret 	=	flexoFBManager::update_likes();
		}else{
			$ret	=	$vars['likes'];
		}
		return $ret;
	}
	
	
	public static function get_cache_comments($post_id=null){
		$ret	=	0;
		$vars	=	flexoFBManager::post_vars($post_id);
		if($vars['comments'] == null){
			$ret 	=	flexoFBManager::update_comments();
		}else{
			$ret	=	$vars['comments'];
		}
		return $vars['comments'];
	}	

	public static	function admin_on_post_show(){
	 	add_meta_box('add_fb', 'Add Facebook ', 'flexoFBManager::show_fb_manager', 'post', 'normal', 'high' );
	}
	public static function show_fb_manager (){
		
		$data=flexoFBManager::post_vars($post_id=null);
		$check=$data['fb_check'];
	//	echo "<pre>";print_r($data);echo "</pre>";	
		?>
		
		Add Facebook form
		<br />
			
		<input type="radio" name="fb_check" value="no" <?php echo $check == 'no' ? 'checked' : ''; ?>/>no
		<input type="radio" name="fb_check" value="yes" <?php echo $check == 'yes' ? 'checked' : ''; ?>/>All
		<input type="radio" name="fb_check" value="like" <?php echo $check == 'like' ? 'checked' : ''; ?>/>Like
		<input type="radio" name="fb_check" value="comments" <?php echo $check == 'comments' ? 'checked' :'';?>/>Comments
		<?php

	}
	
	public static function admin_on_post_save () {
		global $post;
		
		//echo "<pre>";		print_r($_POST['fb_check']);		echo "</pre>";exit;
		
		if($_POST['fb_check']):
	   update_post_meta($post->ID, "fb_check", $_POST['fb_check']);
	  endif;
		

		
	}
	
	public static function include_facebook($content = ''){
		
		$data=flexoFBManager::post_vars($post_id);
		//echo "<pre>";print_r($data);echo "</pre>";
		
		if (is_single() && $data['fb_check']=="yes"):
	
			$content = $content.(flexoFBManager::get_facebook($post_id));
		endif;
		
		if (is_single() && $data['fb_check']=="like"):
		
			$content = $content.(flexoFBManager::get_facebook($post_id,'like'));
		endif;
		
		if (is_single() && $data['fb_check']=="comments"):
		
			$content = $content.(flexoFBManager::get_facebook($post_id,'comments'));
		endif;
			
					
		return $content;
	}
	
public static function fb_menu_display() {
					if (isset($_POST['submit'])):
							$fb_width1 = addslashes(htmlspecialchars($_POST['width']));
							$fb_appId1 = addslashes(htmlspecialchars($_POST['appId']));
							$fb_num_posts1 = addslashes(htmlspecialchars($_POST['num_posts']));
							$fb_feed1 = addslashes(htmlspecialchars($_POST['feed']));
							$fb_type1 = addslashes(htmlspecialchars($_POST['type']));
	
							update_option(fb_width, $fb_width1);
							update_option(fb_appId, $fb_appId1);
							update_option(fb_num_posts, $fb_num_posts1);
							update_option(fb_feed, $fb_feed1);
							update_option(fb_type, $fb_type1);
					endif;
	?>
	<style>
	.fb_admin  {
		padding:10px;
		}
		.fb_admin input{
			margin:10px;
		} 
		</style>
		
		<div class="fb_admin">
			
		<form method="POST">
			</br>width<input type="text" name="width" value="<?php echo get_option(fb_width); ?>"/>
	
			</br>appId<input type="text" name="appId" value="<?php echo get_option(fb_appId); ?>"/>
	
			</br>num_posts<input type="text" name="num_posts" value="<?php echo get_option(fb_num_posts); ?>"/>
	
			</br>feed<input type="text" name="feed" value="<?php echo get_option(fb_feed); ?>"/>			
			
			</br>Type: 	
				<input type="radio" name="type" value="html" <?php echo get_option(fb_type) == 'html' ? 'checked' : ''; ?>/>HTML5
				<input type="radio" name="type" value="xfbml" <?php echo get_option(fb_type) == 'xfbml' ? 'checked' : ''; ?>/>XFBML
				<input type="radio" name="type" value="iframe" <?php echo get_option(fb_type) == 'iframe' ? 'checked' : ''; ?>/>IFRAME
			
			</br><input type="submit" name="submit" value="Save">
	</form>
		</div>
		

	<?php
			
					
				
	}

	public static function fb_id(){
		$fb_appId1=get_option(fb_appId);
		return $fb_appId1;
	}
	
	public static function get_form($post_id=null,$type='default',$url="") {
		
		if (!$url)
 			$rurl	= flexoFBManager::get_url($post_id);
		else
			$rurl = urlencode($url);
		
		//echo "<pre>".$rurl."</pre>";
		
 		$fb_width1=get_option(fb_width);
 		$fb_appId1=self::fb_id();
 		$fb_num_posts1=get_option(fb_num_posts);
 		$fb_feed1=get_option(fb_feed);
 		$fb_type1=get_option(fb_type);
 		switch($fb_type1):
 			case 'html':
 				$form = self::get_html_form($rurl,$fb_appId1,$fb_num_posts1,$fb_width1,$type);
			break;
			
			case 'xfbml':
					$form = self::get_xfbml_form($rurl,$fb_appId1,$fb_num_posts1,$fb_width1,$type);
			break;
			case 'iframe':
		 		 $form = self::get_iframe_form($post_id,$rurl,$fb_appId1,$fb_num_posts1,$fb_width1,$type);
				break;
			
 		endswitch;
	return $form;
		
	}
	
	public static function get_html_form($rurl,$fb_appId1,$fb_num_posts1,$fb_width1,$case){
			echo 'sdf';echo $case;
		switch($case):
			case 'default':
				$form = '<div id="fb-root"></div>
						<script>(function(d, s, id) {
					  var js, fjs = d.getElementsByTagName(s)[0];
					  if (d.getElementById(id)) {return;}
					  js = d.createElement(s); js.id = id;
					  js.src = "//connect.facebook.net/en_GB/all.js#xfbml=1&appId='.$fb_appId1.'";
					  fjs.parentNode.insertBefore(js, fjs);
						}(document, "script", "facebook-jssdk"));</script>
						<div class="fb-like" data-send="false" data-width="'.$fb_width1.'" data-show-faces="false"></div> 
						<div class="fb-comments" data-href="'.$rurl.'" data-num-posts="'.$fb_num_posts1.'" data-width="'.$fb_width1.'"></div>';
					break;
					
				case 'comments':
		 			$form ='<div id="fb-root"></div>
						<script>(function(d, s, id) {
						  var js, fjs = d.getElementsByTagName(s)[0];
						  if (d.getElementById(id)) {return;}
						  js = d.createElement(s); js.id = id;
						  js.src = "//connect.facebook.net/en_GB/all.js#xfbml=1&appId='.$fb_appId1.'";
						  fjs.parentNode.insertBefore(js, fjs);
						}(document, "script", "facebook-jssdk"));</script> 
						<div class="fb-comments" data-href="'.$rurl.'" data-num-posts="'.$fb_num_posts1.'" data-width="'.$fb_width1.'"></div>';
				break;	
				case 'like':
					$form = '<div id="fb-root"></div>
							<script>(function(d, s, id) {
						  var js, fjs = d.getElementsByTagName(s)[0];
						  if (d.getElementById(id)) {return;}
						  js = d.createElement(s); js.id = id;
						  js.src = "//connect.facebook.net/en_GB/all.js#xfbml=1&appId='.$fb_appId1.'";
						  fjs.parentNode.insertBefore(js, fjs);
							}(document, "script", "facebook-jssdk"));</script>
							<div class="fb-like" data-send="false" data-width="'.$fb_width1.'" data-show-faces="false"></div> ';
					break;	
 			endswitch;
		return $form;
	}
	
	public static function get_xfbml_form($rurl,$fb_appId1,$fb_num_posts1,$fb_width1,$case) {
		
		switch($case):
			case 'default':
				$form = '<div id="fb-root"></div>
						<script>(function(d, s, id) {
					  var js, fjs = d.getElementsByTagName(s)[0];
					  if (d.getElementById(id)) {return;}
					  js = d.createElement(s); js.id = id;
					  js.src = "//connect.facebook.net/en_GB/all.js#xfbml=1&appId='.$fb_appId1.'";
					  fjs.parentNode.insertBefore(js, fjs);
						}(document, "script", "facebook-jssdk"));</script>
						<html xmlns:fb="http://ogp.me/ns/fb#">
							<fb:like href="'.$rurl.'" send="false" width="'.$fb_width1.'" show_faces="false"></fb:like>
							<fb:comments href="'.$rurl.'" num_posts="'.$fb_num_posts1.'" width="'.$fb_width1.'"></fb:comments>';
					break;
					
				case 'comments':
		 			$form ='<div id="fb-root"></div>
						<script>(function(d, s, id) {
						  var js, fjs = d.getElementsByTagName(s)[0];
						  if (d.getElementById(id)) {return;}
						  js = d.createElement(s); js.id = id;
						  js.src = "//connect.facebook.net/en_GB/all.js#xfbml=1&appId='.$fb_appId1.'";
						  fjs.parentNode.insertBefore(js, fjs);
						}(document, "script", "facebook-jssdk"));</script>
						<html xmlns:fb="http://ogp.me/ns/fb#"> 
						<fb:comments href="'.$rurl.'" num_posts="'.$fb_num_posts1.'" width="'.$fb_width1.'"></fb:comments>';
				break;	
				case 'like':
					$form = '<div id="fb-root"></div>
							<script>(function(d, s, id) {
						  var js, fjs = d.getElementsByTagName(s)[0];
						  if (d.getElementById(id)) {return;}
						  js = d.createElement(s); js.id = id;
						  js.src = "//connect.facebook.net/en_GB/all.js#xfbml=1&appId='.$fb_appId1.'";
						  fjs.parentNode.insertBefore(js, fjs);
							}(document, "script", "facebook-jssdk"));</script>
							<html xmlns:fb="http://ogp.me/ns/fb#">
							<fb:like href="'.$rurl.'" send="false" width="'.$fb_width1.'" show_faces="false"></fb:like>';
					break;	
 			endswitch;
		return $form;
	}
	
	public static function  get_iframe_form($post_id,$rurl,$fb_appId1,$fb_num_posts1,$fb_width1,$case) {

		switch($case):
			case 'default':
				$form = '<iframe src="//www.facebook.com/plugins/like.php?href='.$rurl.'&amp;send=false&amp;layout=standard&amp;width='.$fb_width1.'&amp;show_faces=false&amp;action=like&amp;colorscheme=light&amp;font=tahoma&amp;height=35&amp;appId='.$fb_appId1.'" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:'.$fb_width1.'; height:35px;" allowTransparency="true"></iframe><div id="fb-root"></div><script src="http://connect.facebook.net/en_US/all.js#appId='.$fb_appId1.'&amp;xfbml=1"></script><fb:comments xid="'.$post_id.'" numposts="'.$fb_num_posts1.'" width="'.$fb_width1.'" publish_feed="true"></fb:comments>';
			break;
			case 'like':
				$form = '<iframe src="//www.facebook.com/plugins/like.php?href='.$rurl.'&amp;send=false&amp;layout=standard&amp;width='.$fb_width1.'&amp;show_faces=false&amp;action=like&amp;colorscheme=light&amp;font=tahoma&amp;height=35&amp;appId='.$fb_appId1.'" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:'.$fb_width1.'; height:35px;" allowTransparency="true"></iframe>';
			break;
			case 'comments':
					$form = '<div id="fb-root"></div><script src="http://connect.facebook.net/en_US/all.js#appId='.$fb_appId1.'&amp;xfbml=1"></script><fb:comments xid="'.$post_id.'" numposts="'.$fb_num_posts1.'" width="'.$fb_width1.'" publish_feed="true"></fb:comments>';
			break;
		endswitch;
	return $form;
	}
	public static function fb_menu () {
			add_options_page('fb settings','fb like manager menu','manage_options','fb-manager','flexoFBManager::fb_menu_display','');
	
	}
	
	
	

	
	
	

}//class

/* =Add admin menu
------------------------------------------*/
if(function_exists('add_action')):
	add_action('admin_menu', 'flexoFBManager::fb_menu');
	add_option('fb_width','600','fb_width');
	add_option('fb_appId','119551741454138','fb_appId');
	add_option('fb_num_posts','10','fb_num_posts');
	add_option('fb_feed','true','fb_feed');
	add_option('fb_type','iframe','fb_type');
	
	add_filter('the_content', 'flexoFBManager::include_facebook', 1);
	add_action('admin_menu', 'flexoFBManager::admin_on_post_show' );
	add_action('save_post', 'flexoFBManager::admin_on_post_save');
	add_action('wp_footer', 'flexoFBManager::wp_footer');
endif;
?>